/*
 * HTTPHeader.java
 *
 * Created on September 10, 2005, 3:39 PM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package org.msblabs.http;

/**
 *
 * @author acidus
 */
public class HTTPHeader {
    
    private String name;
    private String value;
            
   
    //parse these 2
    public HTTPHeader(String pair) {
        name = null;
        value = null;
        
        //we cann't split on an :, because header could have : in it
        int i = pair.indexOf(':');
        //first half of string
        if(i > 1) {
            name = pair.substring(0, i).trim();
            value = pair.substring(i+1).trim();
        } else {
            name = pair.trim();
        }
        
    }

    public String getName() {
        return name;
    }
    
    public String getValue() {
        return value;
    }
    
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(name);
        sb.append(": ");
        sb.append(value);
        return sb.toString();
    }
    
}
